%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% SPDX-License-Identifier: LGPL-3.0-or-later
% LICENCE_BLOCK_END
%=============================================================================
format('longE');
%=============================================================================
A = [1 2 3];
R = evalc('A');
REF =      '
A =

     1     2     3

';
assert_isequal(R, REF);
%=============================================================================
A = [1 -10 10];
R = evalc('A');
REF =   '
A =

     1   -10    10

';
assert_isequal(R, REF);
%=============================================================================
A = [1 10 100];
R = evalc('A');
REF =  '
A =

     1    10   100

';
assert_isequal(R, REF);
%=============================================================================
A = [1 10 1000];
R = evalc('A');
REF = '
A =

           1          10        1000

';
assert_isequal(R, REF);
%=============================================================================
A = [1 10 1e5];
R = evalc('A');
REF =    '
A =

           1          10      100000

';
assert_isequal(R, REF);
%=============================================================================
A = [1 10 1e6];
R = evalc('A');
REF = '
A =

           1          10     1000000

';
assert_isequal(R, REF);
%=============================================================================
A = [1 10 1e7];
R = evalc('A');
REF = '
A =

           1          10    10000000

';
assert_isequal(R, REF);
%=============================================================================
A = [1 1000 1e8];
R = evalc('A');
REF =   '
A =

           1        1000   100000000

';
assert_isequal(R, REF);
%=============================================================================
A = -[1 1000 1e8];
R = evalc('A');
REF =  '
A =

          -1       -1000  -100000000

';
assert_isequal(R, REF);
%=============================================================================
A = [1 1000 1e9];
R = evalc('A');
REF =  '
A =

     1.000000000000000e+00     1.000000000000000e+03     1.000000000000000e+09

';
assert_isequal(R, REF);
%=============================================================================
