//=============================================================================
// Copyright (c) 2016-present Allan CORNET (Nelson)
//=============================================================================
// This file is part of the Nelson.
//=============================================================================
// LICENCE_BLOCK_BEGIN
// SPDX-License-Identifier: LGPL-3.0-or-later
// LICENCE_BLOCK_END
//=============================================================================
#pragma once
//=============================================================================
namespace Nelson {
#define HTML_FILE_EXTENSION ".html"
#define HTML_DOCTYPE_HTML_TAG                                                                      \
    "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 "                                               \
    "Strict//EN\"\n\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">"
#define HTML_HTML_IN_TAG "<html xmlns = \"http://www.w3.org/1999/xhtml\">"
#define HTML_HTML_OUT_TAG "</html>"

#define HTML_GENERATOR_TAG "<meta name=\"generator\" content=\n\"HTML Generated by Nelson\"/>"

#define HTML_H1_REFNAME_IN_TAG "<h1 class=\"refname\">"
#define HTML_H1_IN_TAG "<h1>"
#define HTML_H1_OUT_TAG "</h1>"

#define HTML_H2_IN_TAG "<h2>"
#define HTML_H2_OUT_TAG "</h2>"

#define HTML_H3_IN_TAG "<h3>"
#define HTML_H3_OUT_TAG "</h3>"

#define HTML_HR_OUT_TAG "<hr/>"

#define HTML_P_IN_TAG "<p>"
#define HTML_P_OUT_TAG "</p>"

#define HTML_B_IN_TAG "<b>"
#define HTML_B_OUT_TAG "</b>"

#define HTML_TR_IN_TAG "<tr>"
#define HTML_TR_OUT_TAG "</tr>"

#define HTML_TD_IN_TAG "<td>"
#define HTML_TD_OUT_TAG "</td>"

#define HTML_TH_IN_TAG "<th>"
#define HTML_TH_OUT_TAG "</th>"

#define HTML_DT_IN_TAG "<dt>"
#define HTML_DT_OUT_TAG "</dt>"

#define HTML_DD_IN_TAG "<dd>"
#define HTML_DD_OUT_TAG "</dd>"

#define HTML_DL_IN_TAG "<dl>"
#define HTML_DL_OUT_TAG "</dl>"

#define HTML_HEAD_IN_TAG "<head>"
#define HTML_HEAD_OUT_TAG "</head>"

#define HTML_TITLE_IN_TAG "<title>"
#define HTML_TITLE_OUT_TAG "</title>"

#define HTML_TABLE_IN_TAG "<table>"
#define HTML_TABLE_OUT_TAG "</table>"

#define HTML_STYLE_IN_TAG "<style>"
#define HTML_STYLE_OUT_TAG "</style>"

#define HTML_SCRIPT_IN_TAG "<script>"
#define HTML_SCRIPT_OUT_TAG "</script>"

#define HTML_BODY_IN_TAG "<body>"
#define HTML_BODY_OUT_TAG "</body>"

#define HTML_COMMENT_IN_TAG "<!--"
#define HTML_COMMENT_OUT_TAG "-->"

#define HTML_PRE_IN_TAG "<pre>"
#define HTML_PRE_OUT_TAG "</pre>"

#define HTML_DIV_IN_TAG "<div>"
#define HTML_DIV_OUT_TAG "</div>"

#define HTML_CODE_OUT_TAG "</code>"

#define HTML_A_OUT_TAG "</a>"

#define HTML_LI_IN_TAG "<li>"
#define HTML_LI_OUT_TAG "</li>"

#define HTML_UL_IN_TAG "<ul>"
#define HTML_UL_OUT_TAG "</ul>"

#define HTML_SPAN_OUT_TAG "</span>"

#define HTML_PROGRAMLISTING_TAG "<div class=\"programlisting\">"
} // namespace Nelson
//=============================================================================
