//=============================================================================
// Copyright (c) 2016-present Allan CORNET (Nelson)
//=============================================================================
// This file is part of the Nelson.
//=============================================================================
// LICENCE_BLOCK_BEGIN
// SPDX-License-Identifier: LGPL-3.0-or-later
// LICENCE_BLOCK_END
//=============================================================================
#include "Operators.hpp"
#include <cstring>
//=============================================================================
namespace Nelson {
//=============================================================================
static wstringVector operatorsList = { L"+", L"-", L".*", L"*", L"./", L"/", L".\\", L"\\", L".^",
    L"^", L".'", L"'", L"==", L"~=", L">", L">=", L"<", L"<=", L"&", L"|", L"&&", L"||", L"~" };
//=============================================================================
wstringVector
GetOperators()
{
    return operatorsList;
}
//=============================================================================
bool
isOperator(const std::wstring& key)
{
    for (const auto& k : operatorsList) {
        if (key == k) {
            return true;
        }
    }
    return false;
}
//=============================================================================
} // namespace Nelson
//=============================================================================
