%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% SPDX-License-Identifier: LGPL-3.0-or-later
% LICENCE_BLOCK_END
%=============================================================================
assert_isequal(nargin('datenum'), 6);
assert_isequal(nargout('datenum'), 1);
%=============================================================================
d = datenum([1973, 8, 4, 12, 1, 18]);
REF = 720840.500902777770534;
assert_isequal(d, REF);
%=============================================================================
R = datevec(d);
REF = [1973, 8, 4, 12, 1, 18];
assert_isequal(R, REF);
%=============================================================================
d = datenum('04-Aug-1973 12:01:18');
REF = 720840.500902777770534;
assert_isequal(d, REF);
%=============================================================================
assert_isequal(datenum(1973, 8, 4), 720840);
assert_isequal(datenum(1970, 1, 1), 719529);
%=============================================================================
dv = datevec(datenum('10-Mar-2010 16:48:17'));
REF = [2010           3          10          16          48          17];
assert_isequal(fix(dv), REF);
%=============================================================================
dv = datevec(datenum('12-Mar-2010'));
REF = [2010           3          12           0           0           0];
assert_isequal(fix(dv), REF);
%=============================================================================
dv = datevec(datenum('03/10/2010'));
REF = [2010           3          10           0           0           0];
assert_isequal(dv, REF);
%=============================================================================
dv = datevec(datenum('03/10/00'));
REF = [2000           3          10           0           0           0];
assert_isequal(dv, REF);
%=============================================================================
dv = datevec(datenum('03/10'));
REF = [2018           3          10           0           0           0];
assert_isequal(dv(2:end), REF(2:end));
%=============================================================================
dv = datevec(datenum('2010-03-10 16:48:17'));
REF = [2010           3          10          16          48          17];
assert_isequal(fix(dv), REF);
%=============================================================================
dv = datevec(datenum('2010-03-10'));
REF = [2010           3          10           0           0           0];
assert_isequal(dv, REF);
%=============================================================================
dv = datevec(datenum('2000/03/10'));
REF = [2000           3          10           0           0           0];
assert_isequal(fix(dv), REF);
%=============================================================================
dv = datevec(datenum('16:48:17'));
r = datevec(now());
REF = [r(1), 1, 1, 16, 48, 17];
assert_isequal(fix(dv), REF);
%=============================================================================
dv = datevec(datenum('03:48:17 PM'));
REF = [r(1), 1, 1, 15, 48, 17];
assert_isequal(dv, REF);
%=============================================================================
dv = datevec(datenum('03:48:17 AM'));
REF = [r(1), 1, 1, 3, 48, 17];
assert_isequal(dv, REF);
%=============================================================================
dn = datenum('16:48');
REF = datenum([r(1), 1, 1, 16, 48, 0]);
assert_isequal(dn, REF);
%=============================================================================
dn = datenum('03:35 PM');
REF = datenum([r(1), 1, 1, 15, 35, 0]);
assert_isequal(dn, REF);
%=============================================================================
dn = datenum('03:35 AM');
REF = datenum([r(1), 1, 1, 3, 35, 0]);
assert_isequal(dn, REF);
%=============================================================================
dv = datevec(datenum('10-Mar-2010 16:48:17'));
REF = [2010           3          10          16          48          17];
%assert_isequal(dv, REF);
%=============================================================================
dv = datevec(datenum('Mar.10,2010'));
REF = [2010           3          10           0           0           0];
%assert_isequal(dv, REF);
%=============================================================================
